#ifndef _ADT_H_
#define _ADT_H_

struct ADT_PT {

  int        no, ptr;
  double     x[6];
  void     * data;

};

struct ADT_TREE {

  int        no;
  int        depth;
  int        Npts;
  double     a[6], b[6];
  ADT_TREE * father;
  ADT_TREE * son[2];
  ADT_PT   * Pt;
  ADT_PT  ** Pts;

};

extern void Compute_Root_BoundingBox(int,int,ADT_PT **,double *,double *);
extern ADT_TREE * Create_ADT_TREE(int,int,ADT_PT **,double *,double *);
extern ADT_TREE * Create_ADT_root(int,double *,double *,int,ADT_PT **);
extern void Create_new_subtrees(int *,ADT_TREE **,ADT_TREE **,int);
extern void Divide_subtree(ADT_TREE *,int);
extern void Check_subtree(ADT_TREE *,int *,ADT_TREE **);
extern void Pts_in_target_R(ADT_TREE *,double *,double *,int,int *,ADT_PT **);
extern void Pts_in_target_NR(ADT_TREE *,double *,double *,int,int *,ADT_PT **,ADT_TREE **);
extern int S_overlap_target(ADT_TREE *,double *,double *,int);
extern ADT_PT * Alloc_ADT_PT(int,double *,int);
extern ADT_TREE * Alloc_ADT_TREE(int,ADT_TREE *);
extern int Compare0_ADT_PT(const void *,const void *);
extern int Compare1_ADT_PT(const void *,const void *);
extern int Compare2_ADT_PT(const void *,const void *);
extern int Compare3_ADT_PT(const void *,const void *);
extern int Compare4_ADT_PT(const void *,const void *);
extern int Compare5_ADT_PT(const void *,const void *);
extern int CompareNo_ADT_PT(const void *,const void *);
extern void Print_Subtree(ADT_TREE *,int,char *);

extern void SetUp_ADT_PTS();

#endif
