#ifndef _EDGE_H_
#define _EDGE_H_

#ifdef OLD_STL
#include <map.h>
#include <pair.h>
#else
#include <map>
#include <utility>
using namespace std;
#endif

//-------------------------------------------------------------------------------

class EdgeSet {

public:

  typedef map< pair<int, int>, int > MapPair;
  typedef pair<int, int> Pair;

private:

  int numEdges;
  MapPair mp;

public:

  EdgeSet() { numEdges = 0; }
  ~EdgeSet() {}

  int find(int first, int second);
  int size() const { return numEdges; }

  MapPair::iterator begin() { return mp.begin(); }
  MapPair::iterator end() { return mp.end(); }

};

//-------------------------------------------------------------------------------

inline
int EdgeSet::find(int first, int second)
{

  if (first > second) swap(first,second);

  MapPair::iterator v = mp.find(Pair(first,second));

  if (v == mp.end()) {
    mp[ Pair(first,second) ] = numEdges;
    return numEdges++;
  }

  return v->second;

}

//-------------------------------------------------------------------------------

#endif
