#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#include <Face.h>
#include <Vector.h>
#include <BinFileHandler.h>

//-------------------------------------------------------------------------------

void Face::reorient(SVec<double,3> &X, Vec3D &planeNormal)
{

  Vec3D x[4] = {X[ nodeNum[0] ], X[ nodeNum[1] ], X[ nodeNum[2] ]};

  Vec3D normal = 0.5 * ((x[2] - x[0]) ^ (x[1] - x[0]));
  
  normal *= 1.0 / sqrt(normal*normal);

  if (normal*planeNormal < 0.0)
    swap(nodeNum[1], nodeNum[2]);

}

//-------------------------------------------------------------------------------

void FaceSet::read(int _numFaces, FILE *fptr)  
{

  char line[MAXLINE];

  numFaces = _numFaces;

  faces = new Face[numFaces];

  int i;
  for (i=0; i<numFaces; ++i) {
    fgets(line, MAXLINE, fptr);
    int code;
    sscanf(line, "%d", &code);
    faces[i].setCode(code);
  }

  for (i=0; i<numFaces; ++i) {

    fgets(line, MAXLINE, fptr);
    sscanf(line, "%d %d %d", &faces[i][0], &faces[i][1], &faces[i][2]);
    for (int j=0; j<3; ++j) faces[i][j] -= 1;

  }

  fprintf(stdout, "       %d boundary faces\n", numFaces);

}

//-------------------------------------------------------------------------------

void FaceSet::read(int _numFaces, int (*data)[4])  
{

  numFaces = _numFaces;

  faces = new Face[numFaces];

  for (int i=0; i<numFaces; ++i) {
    for (int j=0; j<3; ++j) 
      faces[i][j] = data[i][j];
    faces[i].setCode(data[i][3]);
  }

}

//-------------------------------------------------------------------------------
