#ifndef _FACES_H_
#define _FACES_H_

#ifdef OLD_STL
#include <defalloc.h>
#include <algo.h>
#else
#include <algorithm>
using namespace std;
#endif

#include <Node.h>
#include <Edge.h>

class BinFileHandler;
template <class Scalar> class Vec;

//-------------------------------------------------------------------------------

class Face {

  int code;
  int nodeNum[3];

public:

  Face() { code = 0; }
  ~Face() {}

  int &operator[](int i) { return nodeNum[i]; }
  int operator[](int i) const { return nodeNum[i]; }
  operator int *() { return nodeNum; }

  bool operator<(const Face &f) const
  {
    return nodeNum[0] < f.nodeNum[0] ||
      (!(f.nodeNum[0] < nodeNum[0]) && 
       nodeNum[1] < f.nodeNum[1]) ||
      (!(f.nodeNum[0] < nodeNum[0]) && 
       !(f.nodeNum[1] < nodeNum[1]) && 
       nodeNum[2] < f.nodeNum[2]);
  }

  /*
  bool operator<(const Face &f) const
  {

    int f1[3] = { nodeNum[0], nodeNum[1], nodeNum[2] };
    int f2[3] = { f.nodeNum[0], f.nodeNum[1], f.nodeNum[2] };

    stable_sort(&f1[0], &f1[3]);
    stable_sort(&f2[0], &f2[3]);

    return (f1[0] < f2[0]) ||
      (!(f2[0] < f1[0]) && f1[1] < f2[1]) ||
      (!(f2[0] < f1[0]) && !(f2[1] < f1[1]) && f1[2] < f2[2]);
  }
  */
  /*
  bool operator==(const Face &f) const
  {

    int f1[3] = { nodeNum[0], nodeNum[1], nodeNum[2]};
    int f2[3] = { f.nodeNum[0], f.nodeNum[1], f.nodeNum[2]};

    stable_sort(&f1[0], &f1[3]);
    stable_sort(&f2[0], &f2[3]);

    return f1[0] == f2[0] && f1[1] == f2[1] && f1[2] == f2[2];

    //return nodeNum[0] == f.nodeNum[0] &&
    //       nodeNum[1] == f.nodeNum[1] &&
    //       nodeNum[2] == f.nodeNum[2];
  }
  */

  void reorient(SVec<double,3> &, Vec3D &);

  void reorder() { stable_sort(&nodeNum[0], &nodeNum[3]); }
  void setCode(int _code) { code = _code; }
  int getCode() const { return code; }
  const int *getNodeNum() const { return nodeNum; }

};

//-------------------------------------------------------------------------------

class FaceSet {

  int numFaces;
  Face *faces;
	
public:

  FaceSet() { numFaces = 0; faces = 0; }
  ~FaceSet() { if (faces) delete[] faces; }

  Face &operator[](int i) const { return faces[i]; }

  void read(int, FILE *);
  void read(int, int (*)[4]);

  int size() const { return numFaces; }
  void resize(int n) { numFaces = n; faces = new Face[numFaces]; }

};

//------------------------------------------------------------------------------

#ifdef OLD_STL
typedef map<Face, pair<int,int>, less<Face> > FaceMap;
#else
typedef map<Face, pair<int,int> > FaceMap;
#endif

//-------------------------------------------------------------------------------

#endif
