#ifndef GET_TIME_H_
#define GET_TIME_H_

#include <stdlib.h>
#include <sys/time.h>
#include <sys/resource.h>

//-------------------------------------------------------------------------------
// function to get current time

inline
double getTime()
{

  static double micro = 1.e-6;

  timeval tp;
  struct timezone tz;
 
  gettimeofday(&tp, &tz);

  // return 1000.0*tp.tv_sec + tp.tv_usec/1000.0;
  return double(tp.tv_sec) + double(tp.tv_usec) * micro;

}

//-------------------------------------------------------------------------------

inline
double getCpuTime()
{

  static struct rusage r;
  static double micro = 1.e-6;

  double t;

  getrusage(RUSAGE_SELF,&r);

  // maximum resident set size utilized (in kilobytes)
  // size = r.ru_maxrss;

  // amount of time spent executing in user mode (in seconds)
  t = double(r.ru_utime.tv_sec) + double(r.ru_utime.tv_usec) * micro;

  // amount of time spent in the system executing on behalf of the process(es)
  t += double(r.ru_stime.tv_sec) + double(r.ru_stime.tv_usec) * micro;

  return t;

}

//-------------------------------------------------------------------------------

#endif
