#include <Tet.h>
#include <Vector.h>
#include <iostream>
//-------------------------------------------------------------------------------

template<int dim>
void Tet::interpolateSolution(SVec<double,3>& nodes, SVec<double,dim> &u, 
			      double *p, double *up)
{
  
  std::cout << "interpolate" << std::endl;

  double* p0 = nodes[ nodeNum[0] ];
  double* p1 = nodes[ nodeNum[1] ];
  double* p2 = nodes[ nodeNum[2] ];
  double* p3 = nodes[ nodeNum[3] ];

  double t1 = p2[1]*p3[2];
  double t2 = p2[2]*p3[1];
  double t3 = p1[1]*p3[2];
  double t4 = p1[2]*p3[1];
  double t5 = p1[1]*p2[2];
  double t6 = p1[2]*p2[1];
  double t8 = p1[0]*p2[1];
  double t9 = t8*p3[2];
  double t10 = p1[0]*p2[2];
  double t11 = t10*p3[1];
  double t12 = p1[1]*p2[0];
  double t13 = t12*p3[2];
  double t14 = p1[2]*p2[0];
  double t15 = t14*p3[1];
  double t16 = p1[1]*p3[0];
  double t17 = t16*p2[2];
  double t18 = p1[2]*p3[0];
  double t19 = t18*p2[1];
  double t20 = p0[0]*p2[1];
  double t21 = t20*p3[2];
  double t22 = p0[0]*p2[2];
  double t23 = t22*p3[1];
  double t24 = p2[0]*p0[1];
  double t25 = t24*p3[2];
  double t26 = p2[0]*p0[2];
  double t27 = t26*p3[1];
  double t28 = p3[0]*p0[1];
  double t29 = t28*p2[2];
  double t30 = p3[0]*p0[2];
  double t31 = t30*p2[1];
  double t32 = -t9+t11+t13-t15-t17+t19+t21-t23-t25+t27+t29-t31;
  double t33 = p0[0]*p1[1];
  double t34 = t33*p3[2];
  double t35 = p0[0]*p1[2];
  double t36 = t35*p3[1];
  double t37 = p1[0]*p0[1];
  double t38 = t37*p3[2];
  double t39 = p1[0]*p0[2];
  double t40 = t39*p3[1];
  double t41 = t28*p1[2];
  double t42 = t30*p1[1];
  double t43 = t33*p2[2];
  double t44 = t35*p2[1];
  double t45 = t37*p2[2];
  double t46 = t39*p2[1];
  double t47 = t24*p1[2];
  double t48 = t26*p1[1];
  double t49 = -t34+t36+t38-t40-t41+t42+t43-t44-t45+t46+t47-t48;
  double t51 = 1./(t32+t49);
  double t53 = p1[0]*p3[2];
  double t54 = p0[0]*p3[2];
  double t57 = p0[1]*p3[2];
  double t58 = p0[2]*p3[1];
  double t59 = p0[1]*p2[2];
  double t60 = p0[2]*p2[1];
  double t65 = p0[1]*p1[2];
  double t66 = p0[2]*p1[1];
  double t69 = p2[0]*p3[1];
  double t70 = p2[1]*p3[0];
  double t71 = p1[0]*p3[1];
  double t78 = p0[0]*p3[1];
  double t83 = p2[0]*p3[2];
  double t84 = p2[2]*p3[0];

  double W[4][4];
  W[0][0] = -(t9-t11-t13+t15+t17-t19)*t51;
  W[0][1] = (t21-t23-t25+t27+t29-t31)*t51;
  W[0][2] = -(t34-t36-t38+t40+t41-t42)*t51;
  W[0][3] = (t43-t44-t45+t46+t47-t48)*t51;

  W[1][0] = (t1-t2-t3+t4+t5-t6)*t51;
  W[1][1] = -(t1-t2-t57+t58+t59-t60)*t51;
  W[1][2] = (t3-t4-t57+t58+t65-t66)*t51;
  W[1][3] = -(t5-t6-t59+t60+t65-t66)*t51;

  W[2][0] = -(t83-t84-t53+t18+t10-t14)*t51;
  W[2][1] = (t83-t84-t54+t30+t22-t26)*t51;
  W[2][2] = -(t53-t18-t54+t30+t35-t39)*t51;
  W[2][3] = (t10-t14-t22+t26+t35-t39)*t51;

  W[3][0] = (t69-t70-t71+t16+t8-t12)*t51;
  W[3][1] = -(t69-t70-t78+t28+t20-t24)*t51;
  W[3][2] = (t71-t16-t78+t28+t33-t37)*t51;
  W[3][3] = -(t8-t12-t20+t24+t33-t37)*t51;

  double *u0 = u[ nodeNum[0] ];
  double *u1 = u[ nodeNum[1] ];
  double *u2 = u[ nodeNum[2] ];
  double *u3 = u[ nodeNum[3] ];

  for (int j=0; j<dim; ++j) {
    double a0 = W[0][0]*u0[j] + W[0][1]*u1[j] + W[0][2]*u2[j] + W[0][3]*u3[j];
    double a1 = W[1][0]*u0[j] + W[1][1]*u1[j] + W[1][2]*u2[j] + W[1][3]*u3[j];
    double a2 = W[2][0]*u0[j] + W[2][1]*u1[j] + W[2][2]*u2[j] + W[2][3]*u3[j];
    double a3 = W[3][0]*u0[j] + W[3][1]*u1[j] + W[3][2]*u2[j] + W[3][3]*u3[j];

    up[j] = a0 + a1*p[0] + a2*p[1] + a3*p[2];
  }

}

//-------------------------------------------------------------------------------

template<int dim>
void Tet::deriveSolution(SVec<double,3>& nodes, SVec<double,dim>& u, 
			 double* dudx, double* dudy, double* dudz)
{

  double dp1dxj[4][3];
  computeGradientP1Function(nodes, dp1dxj);

  double *u0 = u[ nodeNum[0] ];
  double *u1 = u[ nodeNum[1] ];
  double *u2 = u[ nodeNum[2] ];
  double *u3 = u[ nodeNum[3] ];

  for (int j=0; j<dim; ++j) {
    dudx[j] = dp1dxj[0][0]*u0[j] + dp1dxj[1][0]*u1[j] +
      dp1dxj[2][0]*u2[j] + dp1dxj[3][0]*u3[j];
    dudy[j] = dp1dxj[0][1]*u0[j] + dp1dxj[1][1]*u1[j] +
      dp1dxj[2][1]*u2[j] + dp1dxj[3][1]*u3[j];
    dudz[j] = dp1dxj[0][2]*u0[j] + dp1dxj[1][2]*u1[j] +
      dp1dxj[2][2]*u2[j] + dp1dxj[3][2]*u3[j];
  }

}

//-------------------------------------------------------------------------------
